## meshroom 2025.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(meshroom LANGUAGES C CXX)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type for Meshroom plugins" FORCE)
endif()

set(ALICEVISION_ROOT "$ENV{ALICEVISION_ROOT}" CACHE STRING "AliceVision root dir")
set(QT_DIR "$ENV{QT_DIR}" CACHE STRING "Qt root directory")

option(MR_BUILD_QTALICEVISION "Enable building of QtAliceVision plugin" ON)

if(CMAKE_BUILD_TYPE MATCHES Release)
    message(STATUS "Force CMAKE_INSTALL_DO_STRIP in Release")
    set(CMAKE_INSTALL_DO_STRIP ON)
else()
    set(CMAKE_INSTALL_DO_STRIP OFF)
endif()

set(CMAKE_CORE_BUILD_FLAGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE} -DBUILD_SHARED_LIBS:BOOL=ON -DCMAKE_INSTALL_DO_STRIP=${CMAKE_INSTALL_DO_STRIP})

set(ALEMBIC_CMAKE_FLAGS
  -DAlembic_DIR:PATH=${ALICEVISION_ROOT}/lib/cmake/Alembic
  -DImath_DIR=${ALICEVISION_ROOT}/lib/cmake/Imath
)


include(ExternalProject)
# ==============================================================================
# GNUInstallDirs CMake module
# - Define GNU standard installation directories
# - Provides install directory variables as defined by the GNU Coding Standards.
# ==============================================================================
include(GNUInstallDirs)

# message(STATUS "QT_CMAKE_FLAGS: ${QT_CMAKE_FLAGS}")

if(MR_BUILD_QTALICEVISION)
set(QTALICEVISION_TARGET QtAliceVision)
ExternalProject_Add(${QTALICEVISION_TARGET}
      GIT_REPOSITORY https://github.com/alicevision/QtAliceVision
      GIT_TAG develop
      PREFIX ${BUILD_DIR}
      BUILD_IN_SOURCE 0
      BUILD_ALWAYS 0
      SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/QtAliceVision
      BINARY_DIR ${BUILD_DIR}/QtAliceVision_build
      INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
      CONFIGURE_COMMAND ${CMAKE_COMMAND} ${CMAKE_CORE_BUILD_FLAGS} ${ALEMBIC_CMAKE_FLAGS} -DCMAKE_PREFIX_PATH:PATH=${QT_DIR}$<SEMICOLON>${ALICEVISION_ROOT} -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR> <SOURCE_DIR>
      )
endif()

=== requirements.txt ===
# runtime
psutil>=5.6.7
PySide6==6.8.3
markdown==2.6.11
requests==2.32.4
pyseq==0.9.0

=== docs/requirements.txt ===
myst-parser

=== debian/changelog ===
meshroom (2025.1.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1110196)

 -- Dima Kogan <dkogan@debian.org>  Wed, 27 Aug 2025 23:59:29 -0700

=== debian/control ===
Source: meshroom
Section: contrib/science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               python3-setuptools,
               python3-pytest,
               python3-psutil,
               python3-pyside6.qtcore,
               python3-pyside6.qtqml
Standards-Version: 4.6.0
Homepage: https://github.com/alicevision/Meshroom
Vcs-Git: https://salsa.debian.org/science-team/meshroom.git
Vcs-Browser: https://salsa.debian.org/science-team/meshroom

Package: meshroom
Section: contrib/science
Architecture: all
Depends: ${misc:Depends},
               python3,
# grep -h "import Qt" ../**/*.qml | cut -d' ' -f2 | sort -u | perl -pe 'tr/[A-Z]/[a-z]/; s/\./-/g; $_ = "qml6-module-$_"'
               qml6-module-qt3d-core,
               qml6-module-qt3d-extras,
               qml6-module-qt3d-input,
               qml6-module-qt3d-logic,
               qml6-module-qt3d-render,
               qml6-module-qt5compat-graphicaleffects,
               qml6-module-qtcharts,
               qml6-module-qtcore,
               qml6-module-qt-labs-platform,
               qml6-module-qt-labs-qmlmodels,
               qml6-module-qtlocation,
               qml6-module-qtpositioning,
               qml6-module-qtqml,
               qml6-module-qtqml-models,
               qml6-module-qtquick,
               qml6-module-qtquick-controls,
               qml6-module-qtquick-dialogs,
               qml6-module-qtquick-effects,
               qml6-module-qtquick-layouts,
               qml6-module-qtquick-scene3d,
               qml6-module-qtquick-shapes,
# grep -h "from PySide6.* import" ../**/*.py | perl -pe 's/.*from PySide6(.(.*))? import (.*)/$2 $3/g' | xargs -n1 | sed 's/,//g' | sort -u | grep '^Qt.' | perl -pe 'tr/[A-Z]/[a-z]/; s/\./-/g; $_ = "python3-pyside6.$_"'
               python3-pyside6.qt3dcore,
               python3-pyside6.qt3drender,
               python3-pyside6.qtcharts,
               python3-pyside6.qtcore,
               python3-pyside6.qtgui,
# This is a part of QtCore
#               python3-pyside6.qtmsgtype,
               python3-pyside6.qtqml,
               python3-pyside6.qtquick,
               python3-pyside6.qtquickcontrols2,
               python3-pyside6.qtwidgets,
               qt6-3d-assimpsceneimport-plugin,
               qt6-svg-plugins,
               qml-module-alicevision,
               qt6-alicevision-oiio-plugins,
# requirements.txt
               python3-markdown,
               python3-psutil,
               python3-requests,
               python3-pyseq
# extra Depends; do I need these?
# qt6-translations-l10n
# qml6-module-org-kde-ksvg
# python3-pyside6.qtquickwidgets
Description: open-source, node-based visual programming framework
 Meshroom is a flexible toolbox for creating, managing, and executing complex
 data processing pipelines.
 .
 Meshroom uses a nodal system where each node represents a specific operation,
 and output attributes can seamlessly feed into subsequent steps. When a node’s
 attribute is modified, only the affected downstream nodes are invalidated,
 while cached intermediate results are reused to minimize unnecessary
 computation.
 .
 Meshroom supports both local and distributed execution, enabling efficient
 parallel processing on render farms. It also includes interactive widgets for
 visualizing images and 3D data.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	true

override_dh_auto_build:
	true

override_dh_auto_install:
	true

override_dh_install:
	dh_install
	perl -p -i -e 's{#!/usr/bin/env python$$}{#!/usr/bin/python3}' debian/meshroom/usr/bin/*
# don't install pycache
	find debian/meshroom -name __pycache__ -exec rm -r '{}' +
# No executables in /usr/lib
	find debian/meshroom/usr/lib -type f | xargs chmod a-x

# This test eats up all my memory and makes my computer crash
TESTS_EXCLUDE := \
  tests/test_nodeAttributeChangedCallback.py

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(foreach f,$(filter-out $(TESTS_EXCLUDE),$(wildcard tests/test*.py)), pytest $f &&) true
endif

=== debian/watch ===
version=4
https://github.com/alicevision/Meshroom/tags .*/v(\d\S+)\.tar\.gz

## meshroom 2025.1.1

=== debian/changelog ===
meshroom (2025.1.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sat, 20 Dec 2025 19:04:31 -0800

meshroom (2025.1.0-2) unstable; urgency=medium

  * Missing Depends: python3-setuptools
  * Initializing QClipboard in a way that works with the new PySide6

 -- Dima Kogan <dkogan@debian.org>  Tue, 16 Dec 2025 19:18:45 -0800

=== debian/control ===
--- 
+++ 
@@ -61,7 +61,9 @@
                python3-markdown,
                python3-psutil,
                python3-requests,
-               python3-pyseq
+               python3-pyseq,
+# The code imports distutils.util, which needs this
+               python3-setuptools
 # extra Depends; do I need these?
 # qt6-translations-l10n
 # qml6-module-org-kde-ksvg
